Subject: Re: What's cooking in git.git (Dec 2025, #03)

From: Patrick Steinhardt <[email-masked]>
Date: Thu, 18 Dec 2025 07:22:44 +0100

On Thu, Dec 18, 2025 at 11:57:30AM +0900, Junio C Hamano wrote:
> Aaron Plattner <[email-masked]> writes:
> 
> > I'm pretty sure the problem is when do_oid_object_info_extended() 
> > substitutes the blank oi here:
> >
> > 	if (!oi)
> > 		oi = &blank_oi;
> >
> > and then packfile_store_read_object_info() compares it to its own local 
> > blank oi:
> >
> > 	static struct object_info blank_oi = OBJECT_INFO_INIT;
> 
> Ahh, that's an unusual mistake.
> 
> The following was done on top of 'seen', but would it help?  We
> shouldn't have to use the stand-in "blank" thing to begin with.
> 
> Besides, explicitly handling the NULL case would reduce the
> potential chance of errors that somebody accidentally writes into
> blank_oi, making its contents dirty.

Yeah, indeed I've already found that regression myself and got it
cooking in a local patch series. I was holding off from sending that
series because there was a minor conflict with an in-flight one. But
I'll take this opportunity and send it out now.

Thanks for the report and your initial triaging, Junio!

Patrick